<template>
    <div>
        <div class="hidden">
            <input type="text" name="content" v-model="json">
        </div>
        <div class="bg-neutral-500 border border-neutral-400 p-2 rounded">
            <editor-content :editor="editor" />
        </div>
    </div>
</template>

<script>
    import { Editor, EditorContent } from 'tiptap';
    import Limit from "./extensions/Limit";

    export default {
        name: "CommentEditorComponent",
        components: {
            EditorContent,
        },
        props: ["value"],
        data() {
            return {
                editor: null,
                editorChange: false,
                json: null
            };
        },
        mounted() {
            this.editor = new Editor({
                onUpdate: ({ getJSON }) => {
                    this.editorChange = true;
                    this.$emit("input", getJSON());

                    this.json = JSON.stringify(getJSON())
                },
                extensions: [
                    new Limit({
                        limit: 200
                    }),
                ],
                content: this.value,
            });
        },
        beforeDestroy() {
            this.editor.destroy()
        },
        watch: {
            value(val) {

                if (this.editor && !this.editorChange) {
                    this.editor.setContent(val, true);
                }
                this.editorChange = false;
            }
        }
    }
</script>
